%bases = {'abaloneD' 'australianD' 'carD' 'contrasepD' 'diabetesD' 'germanD' 'heartD' 'letterD' 'nurseryD' 'penD' 'segmentD' 'taeD' 'wineD' 'zooD'};
bases = {'fakeD'};

addpath('..')
for i=1:length(bases)
disp('-------------------------------------------')
disp(['    ' bases{i}])
disp('-------------------------------------------')

eval(bases{i})
% provides app test Napp Ntest N ns dag bnet cnode

% evaluation criteria are computation time, log likelyhood and
% classification result
tic
bnet1 = learn_params(bnet,app); % parameters initialization - ML naive Bayes classifier will be compared to ELR classifier
t1=toc

% scg: Scaled Conjugate Gradient
tic
bnet2 = learn_params_elr(bnet1,app,cnode,'batch','scg',true); % main algorithm implemented according to [Gre04] - 'batch' is not used at that moment
t2=toc
% conjgrad: Conjugate Gradient
%tic
%bnet3 = learn_params_elr(bnet1,app,cnode,'batch','conjgrad',true); % to compare the two core algorithms
%t3=toc
tic
bnet4 = learn_params_elr(bnet1,app,cnode,'batch','scg',true,[],[],true); % main algorithm implemented according to [Gre04] - 'batch' is not used at that moment
t4=toc

% evaluation of both classifiers with test data
engine1 = jtree_inf_engine(bnet1);
engine2 = jtree_inf_engine(bnet2);
%engine3 = jtree_inf_engine(bnet3);
engine4 = jtree_inf_engine(bnet4);
mlLL = 0;
elrLL_scg = 0;
%elrLL_cg = 0;
elrLL_scg_with_mixim = 0;
for i=1:Ntest
    evidence = num2cell(test(:,i));
    [aux_engine,LL1] = enter_evidence(engine1,evidence);
    [aux_engine,LL2] = enter_evidence(engine2,evidence);
%    [aux_engine,LL3] = enter_evidence(engine3,evidence);
    [aux_engine,LL4] = enter_evidence(engine4,evidence);
    mlLL = mlLL + LL1;
    elrLL_scg = elrLL_scg + LL2;
%    elrLL_cg = elrLL_cg + LL3;
    elrLL_scg_with_mixim = elrLL_scg_with_mixim + LL4;
end%for
mlLL = mlLL / Ntest
elrLL_scg = elrLL_scg / Ntest
%elrLL_cg = elrLL_cg / Ntest
elrLL_scg_with_mixim = elrLL_scg_with_mixim / Ntest

ml_ratio = classification_evaluation(bnet1,test,cnode)
elr_scg_ratio = classification_evaluation(bnet2,test,cnode)
%elr_cg_ratio = classification_evaluation(bnet3,test,cnode)
elr_scg_with_mixim_ratio = classification_evaluation(bnet4,test,cnode)

% [Gre04] Structural Extension to Logistic Regression: Discriminative
%  Parameter Learning of Belief Net Classifiers, Greiner, R., Zhou, W.,
%  Su, X., Shen, B., 2004

end%for