function bnet_miss = gener_MAR_net(bnet_orig, base_proba, manual, bnet_miss)
% bnet_miss = gener_MAR_net(bnet_orig, base_proba, manual, bnet_miss)
%

%%%%%%%%%%%% INIT
if nargin<4, upd = 0; else upd = 1; end
if nargin<3, manual = 0; end
if nargin<2, error('Not enougth arguments'); end

dag = bnet_orig.dag;
N = size(dag,2);
ns = bnet_orig.node_sizes;

if ~upd,
  ns_miss = zeros(1,2*N);
  ns_miss(1:N) = ns;
  ns_miss(N+1:2*N) = 2*ones(1,N); % 1= node i-N present, 2= node i-N missing

  dag_miss = zeros(2*N,2*N);
  dag_miss(1:N,1:N) = dag;
  dag_miss(N+1:2*N, N+1:2*N) = dag;                                      % A COMMENTER...
  dag_miss(1:N, N+1:2*N) = dag;
  for i=1:N, dag_miss(i, i+N)=1; end

  bnet_miss = mk_bnet(dag_miss, ns_miss);
  CPT = CPT_from_bnet(bnet_orig, 0);
  for i=1:N
    bnet_miss.CPD{i} = tabular_CPD (bnet_miss, i, CPT{i});
  end
else
  dag_mis = zeros(2*N,2*N);
  dag_mis(1:N,1:N) = dag;
  dag_mis(N+1:2*N, N+1:2*N) = dag;
  dag_mis(1:N, N+1:2*N) = dag;
  for i=1:N, dag_mis(i, i+N)=1; end
  
  ns_miss = bnet_miss.node_sizes;
  dag_miss = bnet_miss.dag;
  if dag_miss==dag_mis, clear dag_mis, else error('The bnet is not an MAR bnet'); end
end

%%%%%%%%%%%% Base probability of missing value      ===========> voir pour lancer MCAR
p = base_proba;
if ~upd,
 for i=1:N
  fam = find(dag_miss(:,N+i)==1)';
  semisize = prod(ns_miss(fam)); % as node N+i is binary to say i is present or missing
  CPT = zeros(1,2*semisize);
  CPT(1:semisize) = 1-p;
  CPT(semisize+1:2*semisize) = p;
  bnet_miss.CPD{N+i} = tabular_CPD (bnet_miss, N+i, CPT);
 end
end

%%%%%%%%%%%% manual generation
if manual, 

  b=-1;
  while ~(b==0 | b==1), b = input('Would you like to change a probability of a node to be missing (1 for yes, 0 for no) ?   '); end
  %if b, disp(' BE CAREFULL !! New rules could overwrite old ones partialy or fully !! So the order of entries is important'); end
  
  %%%%%%%%%%%% Update CPT with MAR process
  while b
    fprintf('Nodes are from 1 to %d. ',N);
    i=0;
    while i<1 | i>N | round(i)~=i, i = input('Which node ?   '); end
    fam = find(dag(:,i)==1)'; 
    fam_miss = find(dag_miss(:,N+i)==1)';
    cas = -ones(1, length(fam_miss)+1);
    familly = [fam_miss, N+i];
    fprintf('States are from 1 to %d (-1 for any states, -2 to cancel). For which state of the variable %d ?', ns(i), i);
    state=-3;
    while state<-2 | state>ns(i) | round(state)~=state | state==0, state  = input('   ');end
    if isempty(fam),
        if state==-1,
            p=-1;
            while p<0 | p>1, p = input(' - A priori probability for this node to be missing ?   ');end
            semisize = prod(ns_miss(fam_miss));
            CPT = zeros(1,2*semisize);
            CPT(1:semisize) = 1-p;
            CPT(semisize+1:2*semisize) = p;
            bnet_miss.CPD{N+i} = tabular_CPD (bnet_miss, N+i, CPT);
        elseif state~=-2
            cas = state;
            CPT = CPT_from_bnet(bnet_miss, 0);
            CPT = CPT{N+i};
            p=-1;
            while p<0 | p>1, p = input(' - A priori probability for this node to be missing in this state ?   ');end
            ind = subv2ind(ns_miss(familly),[cas, 1]);
            CPT(ind)=1-p;
            ind = subv2ind(ns_miss(familly),[cas, 2]);
            CPT(ind)=p;
            bnet_miss.CPD{N+i} = tabular_CPD (bnet_miss, N+i, CPT);      
        end
    else 
    if state>-2,
        siz=length(cas);
        place = find(fam_miss==i);
        cas(place) = state;
        
        for k = fam, 
            state1=-3;
            fprintf(' - For the parent named %d, states are from 1 to %d (-1 for any states of this parent). ',k, ns(k));
            while state1<-1 | state1>ns(k) | round(state1)~=state1 | state1==0, state1  = input('Which state ?   ');end
            %place = find(fam_miss==(fam_miss(k)));
            place = find(fam_miss==k);
            cas(place) = state1;               % Present
            if state1~=-1; place = find(fam_miss==(k+N)); cas(place) = 1; end 
        end
        
        p=-1;
        while p<0 | p>1, p = input('Probability in this case of the value to be missing ?   ');end
        CPT = CPT_from_bnet(bnet_miss, 0);
        CPT = CPT{N+i};
        
        cas(end) = 1; % i is present
        subcas_names = find(cas==-1);
        if isempty(subcas_names),
        ind = subv2ind(ns_miss(familly),cas);
        CPT(ind) = 1-p;
        else
            subcas = ones(1, length(subcas_names));
            continu = 1;
            while continu
                cas(subcas_names) = subcas;
                ind = subv2ind(ns_miss(familly),cas);
                CPT(ind) = 1-p;
                [subcas, continu] = next_case(subcas, ns_miss(familly(subcas_names)));
            end
        end
        
        cas(end)=2; % i is missing
        if isempty(subcas_names),
            ind = subv2ind(ns_miss(familly),cas);
            CPT(ind) = p;
        else
            subcas = ones(1, length(subcas_names));
            continu = 1;
            while continu
                cas(subcas_names) = subcas;
                ind = subv2ind(ns_miss(familly),cas);
                CPT(ind) = p;
                [subcas, continu] = next_case(subcas, ns_miss(familly(subcas_names)));
            end
        end
        
        % Verification
            mass = sum(CPT, length(size(CPT)));
            while length(size(mass))>2, mass = prod(mass, length(size(mass))); end
            mass = prod(prod(mass));
            if mass~=1, disp('not a proba...'); end

        bnet_miss.CPD{N+i} = tabular_CPD (bnet_miss, N+i, CPT);
    end %if state~=-2 for the node
  end %if isempty(fam),
  b=-1;
  while ~(b==0 | b==1), b = input('Would you like to change a probability of a node to be missing (1 for yes, 0 for no) ?   ');end
end

%%%%%%%%%%%% automatic generation
else 

    %%%%%%%%%%%% creating MAR process
    CPT = CPT_from_bnet(bnet_miss, 0);
    CPchoice = cell(1, N);
    tot=0;
    for i=1:N, CPchoice{i} = CPT{N+i}; tot = tot + prod(size(CPchoice{i}))/2; end                    %%%  CPchoice  <---------

    N2 = 10; 
    continu = 1; Liste=[];
    while continu
        [tmp Liste1] = gener_problist(base_proba, N2, N2); 
        ff = find(Liste1==base_proba);
        Liste = [Liste Liste1(mysetdiff(1:N2,ff))];
        ss = length(Liste);
        continu = length(Liste)<((rand+1)/2*tot);
    end
    %Liste, mean(Liste)


%%%%%%%%%%%% Update CPT with MAR process
    while ~isempty(Liste)
        % CHOIX DU i ET DE L'ETAT
          i = ceil(N*rand);
        fam = find(dag(:,i)==1)'; 
        fam_miss = find(dag_miss(:,N+i)==1)';
        cas = -ones(1, length(fam_miss)+1);
        familly = [fam_miss, N+i];
        
        %if rand>.666, state=-1; else state=ceil(ns(i)*rand); end
        state=ceil(ns(i)*rand);
        
        p=Liste(1);
        
        if isempty(fam),
%              if state==-1,
%                  semisize = prod(ns_miss(fam_miss));
%                  CPT = zeros(1,2*semisize);
%                  CPT(1:semisize) = 1-p;
%                  CPT(semisize+1:2*semisize) = p;
%                  bnet_miss.CPD{N+i} = tabular_CPD (bnet_miss, N+i, CPT);
%                  
%  %                  Liste = [Liste, (1-p)*ones(1,semisize-1)];
%  %                  Liste = Liste(randperm(length(Liste)));     
%              else
                cas = state;
                CPT = CPT_from_bnet(bnet_miss, 0);
                CPT = CPT{N+i};
                ind = subv2ind(ns_miss(familly),[cas, 1]);
                stateOK=1;
                if CPchoice{i}(ind)==Inf, stateOK = 0; end
                if stateOK,
                    CPT(ind)=1-p;
                    ind = subv2ind(ns_miss(familly),[cas, 2]);
                    CPT(ind)=p;
                    bnet_miss.CPD{N+i} = tabular_CPD (bnet_miss, N+i, CPT);
                end
%              end
        else 
            siz=length(cas);
            place = find(fam_miss==i);
            cas(place) = state;
            
            for k = fam,
%                  if rand>.9, state1=-1; else state1=ceil(ns(k)*rand); end
                state1=ceil(ns(k)*rand); 
                place = find(fam_miss==k);
                cas(place) = state1;               % Present
%                  if state1~=-1; place = find(fam_miss==(k+N)); cas(place) = -1; end 
            end
            
            % Extract the correponding table
            CPT = CPT_from_bnet(bnet_miss, 0);
            CPT = CPT{N+i};
            
            % Test to see if this case were already taken
            stateOK = 1;
            cas(end) = 2;
            subcas_names = find(cas==-1);
            if isempty(subcas_names),
                ind = subv2ind(ns_miss(familly),cas);
                if CPchoice{i}(ind)==Inf, stateOK = 0; end
            else
                subcas = ones(1, length(subcas_names));
                continu = 1;
                while continu & stateOK
                    cas(subcas_names) = subcas;
                    ind = subv2ind(ns_miss(familly),cas);
                    if CPchoice{i}(ind)==Inf, stateOK = stateOK*0; end
                    [subcas, continu] = next_case(subcas, ns_miss(familly(subcas_names)));
                end
            end
            
            % Reactualise CPT
            if stateOK
                cas(end) = 1; % i is present
                if isempty(subcas_names),
                    ind = subv2ind(ns_miss(familly),cas);
                    CPT(ind) = 1-p;
                    CPchoice{i}(ind)=Inf;
                else
                    subcas = ones(1, length(subcas_names));
                    continu = 1;
                    while continu
                        cas(subcas_names) = subcas;
                        ind = subv2ind(ns_miss(familly),cas);
                        CPT(ind) = 1-p;
                        CPchoice{i}(ind)=Inf;
                        [subcas, continu] = next_case(subcas, ns_miss(familly(subcas_names)));
                    end
                end
                
                cas(end)=2; % i is missing
%                  subcas_names
                if isempty(subcas_names),
                    ind = subv2ind(ns_miss(familly),cas);
                    CPT(ind) = p;
                    CPchoice{i}(ind)=Inf;
                else
                    subcas = ones(1, length(subcas_names));
                    continu = 1;
                    countt=0;
                    while continu
                        countt=countt+1;
                        cas(subcas_names) = subcas;
                        ind = subv2ind(ns_miss(familly),cas);
                        CPT(ind) = p;
                        CPchoice{i}(ind)=Inf;
                        [subcas, continu] = next_case(subcas, ns_miss(familly(subcas_names)));
                    end
%                      Liste = [Liste, (1-p)*ones(1,floor(countt/2))];
%                      Liste = Liste(randperm(length(Liste)));
    
                end
                
                % Verification
%                      mass = sum(CPT, length(size(CPT)));
%                      while length(size(mass))>2, mass = prod(mass, length(size(mass))); end
%                      mass = prod(prod(mass));
%                      if mass~=1, disp('not a proba...'); end
                
                % Copy the CPT into the BayesNet
                bnet_miss.CPD{N+i} = tabular_CPD (bnet_miss, N+i, CPT);
            end
        end   % if isempty(fam),
        if stateOK, Liste = Liste(2:end); end
    end
end
