function bnet_miss = gener_MCAR_net(bnet_orig, base_proba, manual, bnet_miss)
% function bnet_miss = gener_MCAR_net(upd, bnet_orig, bnet_miss)
% 

%%%%%%%%%%%% INIT
if nargin<4, upd = 0; else upd = 1; end
if nargin<3, manual = 0; end
if nargin<2, error('Not enougth arguments'); end

dag = bnet_orig.dag;
N = size(dag,2);
ns = bnet_orig.node_sizes;

if nargin<4,
  ns_miss = zeros(1,2*N);
  ns_miss(1:N) = ns;
  ns_miss(N+1:2*N) = 2*ones(1,N); % 1= node i-N present, 2= node i-N missing

  dag_miss = zeros(2*N,2*N);
  dag_miss(1:N,1:N) = dag;

  bnet_miss = mk_bnet(dag_miss, ns_miss);
  CPT = CPT_from_bnet(bnet_orig, 0);
  for i=1:N
    bnet_miss.CPD{i} = tabular_CPD (bnet_miss, i, CPT{i});
  end
else
  ns_miss = bnet_miss.node_sizes;
  dag_miss = bnet_miss.dag;
end

order = 1:2*N;

%%%%%%%%%%%% Base probability of missing value
p = base_proba;
 for i=1:N
  fam = find(dag_miss(:,N+i)==1)';
  semisize = prod(ns_miss(fam)); % as node N+i is binary to say i is present or missing
  CPT = zeros(1,2*semisize);
  CPT(1:semisize) = 1-p;
  CPT(semisize+1:2*semisize) = p;
  bnet_miss.CPD{N+i} = tabular_CPD (bnet_miss, N+i, CPT);
 end


if manual, % manual generation

if upd==1;

 fprintf('Base probability of a data to be missing is %1.4f',base_proba);

 b=-1;
 while ~(b==0 | b==1), b = input('Would you like to change a probability of a node to be missing (1 for yes, 0 for no) ?   '); end

 %%%%%%%%%%%% Update CPT with MCAR process
 while b
  fprintf('Nodes are from 1 to %d. ',N);
  i=0;
  while i<1 | i>N | round(i)~=i, i = input('Which node ?   '); end
  fam = find(dag(:,i)==1)'; 
  fam_miss = find(dag_miss(:,N+i)==1)';
  cas = -ones(1, length(fam_miss)+1);
  familly = [fam_miss, N+i];
      p=-1;
      while p<0 | p>1, p = input(' - A priori probability for this node to be missing ?   ');end
      semisize = prod(ns_miss(fam_miss));
      CPT = zeros(1,2*semisize);
      CPT(1:semisize) = 1-p;
      CPT(semisize+1:2*semisize) = p;
      bnet_miss.CPD{N+i} = tabular_CPD (bnet_miss, N+i, CPT);
  b=-1;
  while ~(b==0 | b==1), b = input('Would you like to change a probability of a node to be missing (1 for yes, 0 for no) ?   ');end
 end
end


else % automatic generation


%%%%%%%%%%%% creating MCAR process
    nbr = N;
    if nbr<34,
        Liste = gener_problist(base_proba, N, nbr);
    else
        nboucles = mod(N,20);
        Liste = [];
    for i=1:nboucles
        Liste1 = gener_problist(base_proba, N, 20);
        Liste = [Liste, Liste1];
    end
        nreste = rem(N,20);
        Liste1 = gener_problist(base_proba, N, nreste);
        Liste = [Liste, Liste1];
    end
    
%%%%%%%%%%%% Update CPT with MCAR process
    for i=1:N
        fam = find(dag(:,i)==1)'; 
        fam_miss = find(dag_miss(:,N+i)==1)';
        cas = -ones(1, length(fam_miss)+1);
        familly = [fam_miss, N+i];
        p = Liste(i);
        semisize = prod(ns_miss(fam_miss));
        CPT = zeros(1,2*semisize);
        CPT(1:semisize) = 1-p;
        CPT(semisize+1:2*semisize) = p;
        bnet_miss.CPD{N+i} = tabular_CPD (bnet_miss, N+i, CPT);
    end

end

